from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
from math import sin, cos, pi, asin, acos
import pygame
from pygame.locals import *
from random import random
from Tkinter import *
from time import time, sleep
from PIL import Image






class Cloud:
    def __init__( self ):
        self.gula = Gula()
        self.body = []
        self.red, self.blue, self.green = 0,0,0
        self.minimalnaVzdialenostKSlnku = None
        self.maximalnaVzdialenostKSlnku = None
    
    def draw( self, vector, farba ):
        if self.velkost > rozlisenie:
            self.body = sorted( self.body, key=lambda bod: bod[0][0]**2 + bod[0][1]**2 + bod[0][2]**2 )
            self.body.reverse()
            glPushMatrix()
            glTranslate( self.x, self.y, self.z )
            glRotate( self.otocenie, 0, 0, 1 )
            if vector[0] == 1:
                glBegin( GL_QUADS )
                for i in range( len( self.body ) ):
                    f = min( 1, max( 0, self.body[i][3] ) )**0.5
                    glColor( self.red+f*farba[0], self.green+f*farba[1], self.blue+f*farba[2], self.body[i][2] )
                    glTexCoord( 0, 0 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]+self.body[i][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 0 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]-self.body[i][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 1 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]-self.body[i][1], self.body[i][0][2]+self.body[i][1] )
                    glTexCoord( 0, 1 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]+self.body[i][1], self.body[i][0][2]+self.body[i][1] )
                glEnd()
            elif vector[0] == -1:
                glBegin( GL_QUADS )
                for i in range( len( self.body ) ):
                    f = min( 1, max( 0, self.body[i][3] ) )**0.5
                    glColor( self.red+f*farba[0], self.green+f*farba[1], self.blue+f*farba[2], self.body[i][2] )
                    glTexCoord( 0, 0 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]-self.body[i][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 0 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]+self.body[i][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 1 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]+self.body[i][1], self.body[i][0][2]+self.body[i][1] )
                    glTexCoord( 0, 1 )
                    glVertex( self.body[i][0][0], self.body[i][0][1]-self.body[i][1], self.body[i][0][2]+self.body[i][1] )
                glEnd()
            elif vector[1] == 1:
                glBegin( GL_QUADS )
                for i in range( len( self.body ) ):
                    f = min( 1, max( 0, self.body[i][3] ) )**0.5
                    glColor( self.red+f*farba[0], self.green+f*farba[1], self.blue+f*farba[2], self.body[i][2] )
                    glTexCoord( 0, 0 )
                    glVertex( self.body[i][0][0]-self.body[i][1], self.body[i][0][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 0 )
                    glVertex( self.body[i][0][0]+self.body[i][1], self.body[i][0][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 1 )
                    glVertex( self.body[i][0][0]+self.body[i][1], self.body[i][0][1], self.body[i][0][2]+self.body[i][1] )
                    glTexCoord( 0, 1 )
                    glVertex( self.body[i][0][0]-self.body[i][1], self.body[i][0][1], self.body[i][0][2]+self.body[i][1] )
                glEnd()
            elif vector[1] == -1:
                glBegin( GL_QUADS )
                for i in range( len( self.body ) ):
                    f = min( 1, max( 0, self.body[i][3] ) )**0.5
                    glColor( self.red+f*farba[0], self.green+f*farba[1], self.blue+f*farba[2], self.body[i][2] )
                    glTexCoord( 0, 0 )
                    glVertex( self.body[i][0][0]+self.body[i][1], self.body[i][0][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 0 )
                    glVertex( self.body[i][0][0]-self.body[i][1], self.body[i][0][1], self.body[i][0][2]-self.body[i][1] )
                    glTexCoord( 1, 1 )
                    glVertex( self.body[i][0][0]-self.body[i][1], self.body[i][0][1], self.body[i][0][2]+self.body[i][1] )
                    glTexCoord( 0, 1 )
                    glVertex( self.body[i][0][0]+self.body[i][1], self.body[i][0][1], self.body[i][0][2]+self.body[i][1] )
                glEnd()
            elif vector[2] == 1:
                glBegin( GL_QUADS )
                for i in range( len( self.body ) ):
                    f = min( 1, max( 0, self.body[i][3] ) )**0.5
                    glColor( self.red+f*farba[0], self.green+f*farba[1], self.blue+f*farba[2], self.body[i][2] )
                    glTexCoord( 0, 0 )
                    glVertex( self.body[i][0][0]+self.body[i][1], self.body[i][0][1]+self.body[i][1], self.body[i][0][2] )
                    glTexCoord( 1, 0 )
                    glVertex( self.body[i][0][0]+self.body[i][1], self.body[i][0][1]-self.body[i][1], self.body[i][0][2] )
                    glTexCoord( 1, 1 )
                    glVertex( self.body[i][0][0]-self.body[i][1], self.body[i][0][1]-self.body[i][1], self.body[i][0][2] )
                    glTexCoord( 0, 1 )
                    glVertex( self.body[i][0][0]-self.body[i][1], self.body[i][0][1]+self.body[i][1], self.body[i][0][2] )
                glEnd()
        
            glPopMatrix()

    def osvetli( self ):
        if self.minimalnaVzdialenostKSlnku != None and self.maximalnaVzdialenostKSlnku != None:
            for i in range( len( self.body ) ):
                if self.maximalnaVzdialenostKSlnku-self.minimalnaVzdialenostKSlnku:
                    a, b = (1.0*self.body[i][3][0]-self.minimalnaVzdialenostKSlnku) / (self.maximalnaVzdialenostKSlnku-self.minimalnaVzdialenostKSlnku), self.body[i][3][1]**2
                    self.body[i][3] = (a**1.5) + (b*0.1)
                else:
                    self.body[i][3] = 0

    def uprav( self, args, sustava ):#x, y, sirka, dlzka, vyska, velkost, hustota, pocet, modVelkost, otocenie ):
        self.velkost = args['velkost']
        self.body = []
        self.minimalnaVzdialenostKSlnku = None
        self.maximalnaVzdialenostKSlnku = None

        self.x = args['x']+args['windX']*(anim-animStart)*200
        self.y = args['y']+args['windY']*(anim-animStart)*200
        d = self.x**2+self.y**2
        d = d**0.5
        args['x'] = 0
        args['y'] = 0
        args['z'] = 0
        self.z = 200-d/5
        self.otocenie = args['otocenie']
        args['oblak'] = self
        
        self.gula.uprav( args, sustava, 0 )

class Gula:
    def __init__( self ):
        self.pocet = 0
        self.pointsize = 0
        self.deti = []
        self.uhly = []
        self.modUhly = []

    def uprav( self, args, sustava, level ):#x, y, z, sirka, dlzka, vyska, velkost, hustota, vzdialenost, pocet, modVelkost, parentUhly=None ):
        s = ((args['oblak'].x+args['x'])**2 + (args['oblak'].y+args['y'])**2 + (args['oblak'].z+args['z'])**2)**0.5
        args['velkost'] *= args['modVelkost']
        self.pointsize = 56.0/s*args['velkost']
        if self.pointsize <= rozlisenie:
            del self.uhly[:]
            del self.deti[:]
            del self.modUhly[:]
            return
        pocet = int( round( args['pocet'] ) )
        del self.uhly[pocet:]
        del self.deti[pocet:]
        del self.modUhly[pocet:]

        self.x = args['x']
        self.y = args['y']
        self.z = args['z']
        self.hustota = args['hustota']

        self.vzdialenostKSlnku = -self.x*sustava[0] -self.y*sustava[1] -self.z*sustava[2]
        if args['oblak'].minimalnaVzdialenostKSlnku == None or self.vzdialenostKSlnku < args['oblak'].minimalnaVzdialenostKSlnku:
            args['oblak'].minimalnaVzdialenostKSlnku = self.vzdialenostKSlnku
        if args['oblak'].maximalnaVzdialenostKSlnku == None or self.vzdialenostKSlnku > args['oblak'].maximalnaVzdialenostKSlnku:
            args['oblak'].maximalnaVzdialenostKSlnku = self.vzdialenostKSlnku

        data = [(self.x, self.y, self.z), args['velkost']*0.015, self.hustota, (self.vzdialenostKSlnku, level) ]
        args['oblak'].body.append( data )

        if pocet == 0:
            return

        for i in range( len( self.deti ), pocet ):
            self.deti.append( Gula() )
            self.modUhly.append( (random(), random()) )
            self.uhly.append( (random()*pi*2, random()*pi) )
        
        self.pocet = pocet
        args['modVelkost'] = args['modVelkost']**2#1.8
        args['velkost'] = args['velkost']*args['modVelkost']
        args['hustota'] = args['hustota']*0.8
        
        for i in range( self.pocet ):
            self.uhly[i] = ((self.uhly[i][0]+self.modUhly[i][0]*animSpeed), (self.uhly[i][1]+self.modUhly[i][1]*animSpeed))
            
            args['x'] = self.x + args['sirka']*0.02*args['velkost'] * cos( self.uhly[i][0] ) * sin( self.uhly[i][1] )
            args['y'] = self.y + args['dlzka']*0.02*args['velkost'] * sin( self.uhly[i][0] ) * sin( self.uhly[i][1] )
            args['z'] = self.z + args['vyska']*0.02*args['velkost'] * cos( self.uhly[i][1] )

            self.deti[i].uprav( args.copy(), sustava, level+1 )

class Skymap:
    def __init__( self, arg='0 0 0 0 0 1 1 1 1 1 1 0' ):
        if arg:
            arg = arg.split()
            self.time = float( arg[0] )
            self.heading = float( arg[1] )
            self.elevation = float( arg[2] )
            wind = float( arg[3] ), float( arg[4] )
            self.windX = cos( wind[0]*pi/180 )*wind[1]*20
            self.windY = sin( wind[0]*pi/180 )*wind[1]*20
            self.sunColor = float( arg[5] ), float( arg[6] ), float( arg[7] )
            self.skyColor = float( arg[8] ), float( arg[9] ), float( arg[10] )
            self.pocet = float( arg[11] )

        self.s = {}
        for y in range( 40 ):
            for x in range( 40 ):
                self.s[x,y] = {
                    'x':int( 10*(x*10+random()*10) )-2000,
                    'y':int( 10*(y*10+random()*10) )-2000,
                    'sirka':1,
                    'dlzka':2,
                    'vyska':1,
                    'velkost':0,
                    'hustota':0,
                    'pocet':self.pocet,
                    'modVelkost':0,
                    'otocenie':0
                }
        self.clouds = {}
        for y in range( 40 ):
            for x in range( 40 ):
                self.clouds[x,y] = Cloud()

    def add( self, args ):
        x = int( args['x']/10 )
        y = int( args['y']/10 )
        args['x'] = args['x']*10-2000
        args['y'] = args['y']*10-2000
        self.s[x, y] = args
    
    def interpolate( self, A, B, b ):
        a = 1.0-b

        self.windX = A.windX*a + B.windX*b
        self.windY = A.windY*a + B.windY*b

        heading = A.heading*a + B.heading*b
        elevation = A.elevation*a + B.elevation*b - 90

        self.sunColor = A.sunColor[0]*a + B.sunColor[0]*b, A.sunColor[1]*a + B.sunColor[1]*b, A.sunColor[2]*a + B.sunColor[2]*b
        self.skyColor = A.skyColor[0]*a + B.skyColor[0]*b, A.skyColor[1]*a + B.skyColor[1]*b, A.skyColor[2]*a + B.skyColor[2]*b
        glClearColor( self.skyColor[0], self.skyColor[1], self.skyColor[2], 0.5 )

        ux = -cos( heading*pi/180 ) * sin( elevation*pi/180 )
        uy = -sin( heading*pi/180 ) * sin( elevation*pi/180 )
        uz = -cos( elevation*pi/180 )

        pocet = round( A.pocet*a + B.pocet*b )

        for y in range( 40 ):
            for x in range( 40 ):
                final = {}
                for i in A[x,y].keys():
                    final[i] = A[x,y][i]*a + B[x,y][i]*b
                final['pocet'] = pocet
                self.s[x,y] = final.copy()
        
        return ux, uy, uz
    
    def make( self, sustavaKSlnku ):
        for y in range( 40 ):
            for x in range( 40 ):
                self.s[x,y]['windX'] = self.windX
                self.s[x,y]['windY'] = self.windY
                self.clouds[x,y].uprav( self.s[x,y].copy(), sustavaKSlnku )
            print '*',
    
    def osvetli( self ):
        for y in range( 40 ):
            for x in range( 40 ):
                self.clouds[x,y].osvetli(  )
    
    def draw( self, vector, upVector, sustavaKSlnku ):
        glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )
        
        glMatrixMode( GL_PROJECTION )
        glLoadIdentity()
        gluPerspective( 90, 1.0, 0.1, 5000.0 )
        
        glMatrixMode( GL_MODELVIEW )
        glLoadIdentity()

        gluLookAt( 0, 0, 0, vector[0], vector[1], vector[2], upVector[0], upVector[1], upVector[2]  )

        d = sustavaKSlnku[0]**2 + sustavaKSlnku[1]**2 + sustavaKSlnku[2]**2
        d = d**0.5
        x = -3000*(sustavaKSlnku[0]/d)
        y = -3000*(sustavaKSlnku[1]/d)
        z = -3000*(sustavaKSlnku[2]/d)

        glDisable( GL_TEXTURE_2D )
        glColor( self.sunColor[0], self.sunColor[1], self.sunColor[2], 1 )
        glPushMatrix()
        glTranslate( x, y, z )
        glutSolidSphere( 100, 10, 10 ) 
        glPopMatrix()

        glEnable( GL_TEXTURE_2D )
        glBindTexture( GL_TEXTURE_2D, textures[0] )

        #glColor( 0.97, 0.97, 0.97, 0.6 )

        for y in range( 40 ):
            for x in range( 40 ):
                self.clouds[x,y].draw( vector, self.sunColor )

        glColor( 1, 1, 1, 1 )

        l = 't'

        if vector[0] == 1:
            l = 'f'
            glBindTexture( GL_TEXTURE_2D, textures[1] )
            glBegin( GL_QUADS )
            glTexCoord( 0, 0 )
            glVertex( 1, -1, -1 )
            glTexCoord( 1, 0 )
            glVertex( 1, 1, -1 )
            glTexCoord( 1, 1 )
            glVertex( 1, 1, 1 )
            glTexCoord( 0, 1 )
            glVertex( 1, -1, 1 )
            glEnd()
        elif vector[0] == -1:
            l = 'b'
            glBindTexture( GL_TEXTURE_2D, textures[1] )
            glBegin( GL_QUADS )
            glTexCoord( 0, 0 )
            glVertex( -1, -1, -1 )
            glTexCoord( 1, 0 )
            glVertex( -1, 1, -1 )
            glTexCoord( 1, 1 )
            glVertex( -1, 1, 1 )
            glTexCoord( 0, 1 )
            glVertex( -1, -1, 1 )
            glEnd()
        elif vector[1] == 1:
            l = 'l'
            glBindTexture( GL_TEXTURE_2D, textures[1] )
            glBegin( GL_QUADS )
            glTexCoord( 0, 0 )
            glVertex( -1, 1, -1 )
            glTexCoord( 1, 0 )
            glVertex( 1, 1, -1 )
            glTexCoord( 1, 1 )
            glVertex( 1, 1, 1 )
            glTexCoord( 0, 1 )
            glVertex( -1, 1, 1 )
            glEnd()
        elif vector[1] == -1:
            l = 'r'
            glBindTexture( GL_TEXTURE_2D, textures[1] )
            glBegin( GL_QUADS )
            glTexCoord( 0, 0 )
            glVertex( 1, -1, -1 )
            glTexCoord( 1, 0 )
            glVertex( -1, -1, -1 )
            glTexCoord( 1, 1 )
            glVertex( -1, -1, 1 )
            glTexCoord( 0, 1 )
            glVertex( 1, -1, 1 )
            glEnd()

        glutSwapBuffers()
        glFinish()
        screenshot( l )
    
    def __getitem__( self, key ):
        try:
            return self.s[key]
        except KeyError:
            return None
    
    def __lt__( self, other ):
        if self.time < other.time:
            return True
        return False
    
    def __le__( self, other ):
        if self.time <= other.time:
            return True
        return False
    
    def __eq__( self, other ):
        if self.time == other.time:
            return True
        return False

    def __ne__( self, other ):
        if self.time != other.time:
            return True
        return False

    def __gt__( self, other ):
        if self.time > other.time:
            return True
        return False

    def __ge__( self, other ):
        if self.time >= other.time:
            return True
        return False
    
    def __repr__( self ):
        return 'skymap at '+str( self.time )



def init():
    global fi, xi, vzd, clouds, anim, animStart

    glShadeModel( GL_SMOOTH )
    glClearColor( 0.41, 0.66, 0.88, 0.5 ) 
    glClearDepth( 1.0 )
    glDepthFunc( GL_LEQUAL )
    glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST )
    
    fi = -0.5
    xi = -0.85
    
    glEnable ( GL_BLEND )
    glBlendFunc ( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
    
    clouds = Skymap()
    glColor( 0.97, 0.97, 0.97, 0.6 )

    print 'setted up'
    loadTextures()
    print 'loaded textures'
    loadSkymaps()
    print 'loaded sky maps'

    anim = skyMaps[0].time
    animStart = anim

    glBindTexture( GL_TEXTURE_2D, textures[0] )
    glEnable( GL_POINT_SPRITE )
    glTexEnvi( GL_POINT_SPRITE, GL_COORD_REPLACE, GL_TRUE )
    vzd = time()

def loadTextures():
    global textures
    
    path = ''
    names = ['texture.png', 'haze.png']
    textures = glGenTextures( len( names ) )
    pygame.init()
    pygame.display.set_mode( (1,1) )
    for i in range( len( names ) ):
        t = pygame.image.load( path+names[i] )
        t.convert_alpha()
        data = pygame.image.tostring( t, "RGBA", 1 )
        glBindTexture( GL_TEXTURE_2D, textures[i] )
        gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, t.get_width(), t.get_height(), GL_RGBA, GL_UNSIGNED_BYTE, data )
        glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR )
        glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
    pygame.quit()

def loadSkymaps():
    global skyMaps
    
    f = open( 'skyfile.sf', 'r' )
    s = f.readlines()
    f.close()
    
    skyMaps = []
    for i in s:
        if i[0] == '#':
            skyMaps.append( Skymap( i[1:-1] ) )
        else:
            args = {
            'x': int( i.split()[0] ),
            'y': int( i.split()[1] ),
            'sirka': 1,
            'dlzka': 2,
            'vyska': 0.4,
            'velkost': float( i.split()[2] )*470,
            'hustota': float( i.split()[3] ),
            'pocet': 15,
            'modVelkost': 0.9,
            'otocenie': 0
            }
            skyMaps[-1].add( args )
    skyMaps.sort()

def screenshot( l ):
    global counter
    data = glReadPixels( 0, 0, 500, 500, GL_RGB, GL_UNSIGNED_BYTE )
    im = Image.frombuffer( "RGB", (500, 500), data, "raw", "RGB", 0, 0 )
    im = im.transpose( Image.FLIP_TOP_BOTTOM )

    #vytvor meno pre obrazok
    num = str( counter/5 )
    num = '0'*(3-len( num )) + num
    num = path+'screenshot_'+ str( l ) + num +'.png'
    im.save( num )
    counter += 1

def render():
    global anim, animT, num, counter2

    #Ts = time()
    d = skyMaps[counter2+1].time - skyMaps[counter2].time
    sustavaKSlnku = clouds.interpolate( skyMaps[counter2], skyMaps[counter2+1], (anim-skyMaps[counter2].time)/d )

    print 'interpolated'
    clouds.make( sustavaKSlnku )
    clouds.osvetli(  )
    print 'made'
    clouds.draw( (1, 0, 0), (0, 0, 1), sustavaKSlnku )
    clouds.draw( (0, 1, 0), (0, 0, 1), sustavaKSlnku )
    clouds.draw( (-1, 0, 0), (0, 0, 1), sustavaKSlnku )
    clouds.draw( (0, -1, 0), (0, 0, 1), sustavaKSlnku )
    clouds.draw( (0, 0, 1), (-1, 0, 0), sustavaKSlnku )

#    Tf = time()
#    c = 0
#    for i in clouds.s.keys():
#        c += len( clouds.s[i]['oblak'].body )
#    print c, 'balls', 'took', Tf-Ts, 'sec.'

    print anim
    anim += 0.01
    if anim >= skyMaps[counter2+1].time:
        #del skyMaps[0]
        counter2 += 1
        if len( skyMaps )-2<counter2:
            print time()-vzd, 'Done here!'
            exit()
    #exit()

def reshape( width, height ):
    glViewport( 0, 0, width, height )

    glMatrixMode( GL_PROJECTION )
    glLoadIdentity()

    gluPerspective( 90, 1.0, 0.1, 5000.0 )

def keyboard( key, x, y ):
    pass

def specialKeyboard( key, x, y ):
    pass

def mouseClick( button, state, x, y ):
    pass

def mouseMove( x, y ):
    pass

def main( argc=[], *argv ):
    glutInit( argc, argv )
    glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE )
    glutInitWindowSize( 500, 500 )
    glutCreateWindow( "--== Dobsovic  -  OpenGL ==--"  )

    init()
    glutDisplayFunc( render )
    glutReshapeFunc( reshape )
    glutKeyboardFunc( keyboard )                      
    glutSpecialFunc( specialKeyboard )
    glutMouseFunc( mouseClick )
    glutMotionFunc( mouseMove )
    glutIdleFunc( render )

    glutMainLoop()
    
    return 0

right_down = False
left_down = False
counter = 0
counter2 = 0
suradnice = []
velkosti = []

if __name__== '__main__':
    global rozlisenie, animSpeed
    path = 'novy\\'
    animSpeed = 0.595
    rozlisenie = 10
    try:
        rozlisenie = sys.argv[2]
        animSpeed = sys.argv[3]
        path = sys.argv[4]
    except IndexError:
        pass
    print path, animSpeed, rozlisenie

    main()

#main()



print "done good"