from Tkinter import *
import random
import pygame
from pygame.locals import *
import os

class Slider:
    def __init__( self, master, name, col, row, args ):
        self.f = Frame( master )
        self.f.grid( column=col, row=row )
        func = args['func']
        del args['func']
        self.name = name
        self.label = Label( self.f, text=name+' :' )
        self.label.grid( column=0, row=0 )
        args['orient'] = 'horizontal'
        args['length'] = 300
        self.var = DoubleVar()
        self.var.set( (args['from_']+args['to'])/2.0 )
        self.slider = Scale( self.f, args, variable=self.var )
        self.slider.grid( column=1, row=0 )
        if func:
            self.slider.bind( '<ButtonRelease-1>', lambda event: func() )
    
    def get( self ):
        return self.var.get()

class DoubleSlider:
    def __init__( self, master, name, col, row, args ):
        self.f = Frame( master )
        self.f.grid( column=col, row=row )
        func = args['func']
        del args['func']
        self.name = name
        self.label = Label( self.f, text=name+' :' )
        self.label.grid( column=0, row=0 )
        args['orient'] = 'horizontal'
        args['length'] = 300
        self.var = DoubleVar()
        self.var.set( (args['from_']+args['to'])/2.0 )
        self.slider = Scale( self.f, args, variable=self.var )
        self.slider.grid( column=1, row=0 )
        if func:
            self.slider.bind( '<ButtonRelease-1>', lambda event: func() )

        self.label2 = Label( self.f, text='rozptyl'+' :' )
        self.label2.grid( column=2, row=0 )
        args['orient'] = 'horizontal'
        args['length'] = 300
        args['from_'] = 0
        args['to'] = 1
        args['resolution'] = 0.01
        self.rozptyl = DoubleVar()
        self.rozptyl.set( 0.5 )
        self.slider2 = Scale( self.f, args, variable=self.rozptyl )
        self.slider2.grid( column=3, row=0 )
        if func:
            self.slider2.bind( '<ButtonRelease-1>', lambda event: func() )

    def get( self ):
        return self.var.get(), self.rozptyl.get()

class ColorPicker:
    def __init__( self, master, name, col, row, args ):
        self.f = Frame( master, relief='ridge', border=2 )
        self.f.grid( column=col, row=row )
        self.name = name
        self.label = Label( self.f, text=name+' :' )
        self.label.grid( column=0, row=0 )
        args['from_'] = 0
        args['to'] = 1
        args['resolution'] = 0.01
        args['func'] = self.showColor
        self.red = Slider( self.f, 'R', 1, 0, args.copy() )
        self.green = Slider( self.f, 'G', 1, 1, args.copy() )
        self.blue = Slider( self.f, 'B', 1, 2, args.copy() )
        self.red.var.set( 0.41 )
        self.green.var.set( 0.66 )
        self.blue.var.set( 0.88 )
        self.b = Button( self.f, width=3, height=1, relief='solid' )
        self.b.grid( column=2, row=1 )
        self.showColor()

    def showColor( self ):
        r = hex( int( self.red.get()*255 ) )[2:]
        r = '0'*(2-len( r )) + r
        g = hex( int( self.green.get()*255 ) )[2:]
        g = '0'*(2-len( g )) + g
        b = hex( int( self.blue.get()*255 ) )[2:]
        b = '0'*(2-len( b )) + b
        f = '#'+ r + g + b
        self.b['bg'] = f
        self.b.update()

    def get( self ):
        return self.red.get(), self.green.get(), self.blue.get()
    
    def getStr( self ):
        return str( self.red.get() )+' '+str( self.green.get() )+' '+str( self.blue.get() )


class App:
    def __init__( self ):
        self.width = 400
        self.height = 400
        self.w = Tk()
        self.f = Frame( self.w, width=self.width, height=self.height )
        self.f.grid( column=0, row=0 )
        os.environ['SDL_WINDOWID'] = str( self.f.winfo_id() )
        pygame.display.init()
        self.screen = pygame.display.set_mode( (self.width, self.height) )
        s = pygame.Surface( (400, 400), 0, 32 )
        self.seed = 0.15648
        self.col = 0
        self.row = 1

        self.reseedB = Button( self.w, text='Obnov' )
        self.reseedB.grid( column=self.col, row=self.row )
        self.reseedB.bind( '<1>', lambda event: self.reseed() )

        self.widgets = {}
        self.addWidget( Slider, 'Cas', from_=0, to=23.9, resolution=0.1, func=None )
        self.widgets['Cas'].var.set( 0 )
        self.addWidget( Slider, 'Pokrytie', from_=0, to=1, resolution=0.01, func=self.redraw )
        self.addWidget( Slider, 'Smer slnka', from_=0, to=720, resolution=1, func=None )
        self.addWidget( Slider, 'Sklon slnka', from_=-90, to=90, resolution=1, func=None )
        self.addWidget( Slider, 'Smer vetra', from_=0, to=720, resolution=1, func=None )
        self.addWidget( Slider, 'Sila vetra', from_=0, to=1, resolution=0.01, func=None )
        self.col += 1
        self.row = 0
        self.addWidget( DoubleSlider, 'Velkost', from_=0, to=1, resolution=0.01, func=self.redraw )
        self.addWidget( DoubleSlider, 'Hustota', from_=0, to=1, resolution=0.01, func=self.redraw )
        self.addWidget( Slider, 'Hutnost', from_=0, to=30, resolution=1, func=None )
        self.addWidget( ColorPicker, 'Farba oblohy', func=None )
        self.addWidget( ColorPicker, 'Farba slnka', func=None )

        self.saveB = Button( self.w, text='Uloz' )
        self.saveB.grid( column=self.col, row=self.row+1 )
        self.saveB.bind( '<1>', lambda event: self.save() )

        self.redraw()

        self.w.mainloop()

    def save( self ):
        f = open( 'skyfile.sf', 'a' )
        uvod = '#'
        uvod += str( self.widgets['Cas'].get() ) + ' '
        uvod += str( self.widgets['Smer slnka'].get() ) + ' '
        uvod += str( self.widgets['Sklon slnka'].get() ) + ' '
        uvod += str( self.widgets['Smer vetra'].get() ) + ' '
        uvod += str( self.widgets['Sila vetra'].get() ) + ' '
        uvod += self.widgets['Farba slnka'].getStr() + ' '
        uvod += self.widgets['Farba oblohy'].getStr() + ' '
        uvod += str( self.widgets['Hutnost'].get() ) + '\n'
        f.write( uvod )
        for i in self.l:
            for j in i:
                f.write( str( j )+' ' )
            f.write( '\n' )
        f.close()

    def reseed( self ):
        self.seed = random.random()
        random.seed( self.seed )
        self.redraw()

    def addWidget( self, type, name, **args ):
        self.row += 1
        self.widgets[name] = type( self.w, name, self.col, self.row, args )

    def redraw( self, *args, **kwargs ):
        random.seed( self.seed )
        self.screen.fill( (0, 0, 0) )
        s = pygame.Surface( (400, 400) )
        self.l = []
        for y in range( 40 ):
            for x in range( 40 ):
                if random.random() < self.widgets['Pokrytie'].get()/4.0:
                    xx = int( x*10+random.random()*10 )
                    yy = int( y*10+random.random()*10 )
                    v = int( self.widgets['Velkost'].get()[0]*70 * (1+self.widgets['Velkost'].get()[1]*(random.random()-0.5) ) )
                    c = min( max( 0, self.widgets['Hustota'].get()[0] * (1+self.widgets['Hustota'].get()[1]*(random.random()-0.5) ) )*255, 255 )
                    self.l.append( (xx, yy, v, c/255.0) )
                    pygame.draw.circle( s, (c, c, c), (xx, yy), max( v, 0 ) )
                    self.screen.blit( s, (0, 0), None, BLEND_MAX )
                    s.fill( (0, 0, 0) )
                else:
                    random.random()
                    random.random()
                    random.random()
                    random.random()
        
        
        pygame.display.flip()



a = App()
















